<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class PenyesuaianstokValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
			array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		if(empty($input["requesterId"])){
			array_push($this->error, ["requesterId" => "cannot be null"]);
		}
		else{
			$lengthrequesterid = strlen($input["requesterId"]);
			if($lengthrequesterid>19){
			array_push($this->error, ["requesterid" => "value too long"]);
			}
		}
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["requesterId"])->first();
		if(empty($users)){
			array_push($this->error, ["requesterId" => "invalid relation"]);
		}
		if(empty($input["transactionType"])){
			array_push($this->error, ["transactionType" => "cannot be null"]);
		}
		else{
			$lengthtype = strlen($input["transactionType"]);
			if($lengthtype>3){
			array_push($this->error, ["transactionType" => "value too long"]);
			}
		}
		if(empty($input["destinationAccount"])){
			array_push($this->error, ["destinationAccount" => "cannot be null"]);
		}
		else{
			$lengthaccount = strlen($input["destinationAccount"]);
			if($lengthaccount>100){
			array_push($this->error, ["destinationAccount" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		if(!empty($input["kapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
			array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		if(!empty($input["locationId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		}
		if(empty($input["requesterId"])){
			array_push($this->error, ["requesterId" => "cannot be null"]);
		}
		else{
			$lengthrequesterid = strlen($input["requesterId"]);
			if($lengthrequesterid>19){
			array_push($this->error, ["requesterid" => "value too long"]);
			}
		}
		if(!empty($input["requesterId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["requesterId"])->first();
		if(empty($users)){
			array_push($this->error, ["requesterId" => "invalid relation"]);
		}
		}
		if(empty($input["transactionType"])){
			array_push($this->error, ["transactionType" => "cannot be null"]);
		}
		else{
			$lengthtype = strlen($input["transactionType"]);
			if($lengthtype>3){
			array_push($this->error, ["transactionType" => "value too long"]);
			}
		}
		if(empty($input["destinationAccount"])){
			array_push($this->error, ["destinationAccount" => "cannot be null"]);
		}
		else{
			$lengthaccount = strlen($input["destinationAccount"]);
			if($lengthaccount>100){
			array_push($this->error, ["destinationAccount" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}